#ifndef __UTILS_H__
#define __UTILS_H__

#include <stdio.h>
#include <sys/types.h>

#if defined(__APPLE__) && defined(__POWERPC__)
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#if defined(WIN32)
#include <winsock2.h>
#pragma comment (lib, "ws2_32.lib")
#else
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif

/*
 * wrappers for system-dependent functions
 */
#if defined(WIN32)
typedef u_short in_port_t;
#define sleep(x) Sleep(x * 1000)
#else // Windows socket wrapper
typedef int SOCKET;
typedef struct sockaddr_in SOCKADDR_IN;
extern int closesocket(SOCKET fd);
#endif

/*
 * utilities for socket connection
 */
extern int setup_server(in_port_t port);
extern int setup_client(char *hostname, in_port_t port);
extern int mserver_socket(in_port_t port, int num);
extern int mserver_maccept(SOCKET soc, int limit, void (*func)());

/*
 * OpenGL wrappers
 */
extern void putString(char *s, double x, double y, int font);

/*
 * miscellaneous utilities
 */
extern char *chop_newline(char *buf, int len);
extern void print_buf(char *buf, int nbyte);
extern int die(int ret, int n, SOCKET *fd);
extern int limit_range(int *val, int min, int max);

#endif // __UTILS_H__
